import java.util.List;
import java.util.ArrayList;
import java.util.Random;

/**
 * Object waarmee kisten worden gevuld met borden.
 */
public class Kistenvuller {

    /** Lijst van kisten die bij het vullen kunnen worden gebruikt. */
    private ArrayList<Kist> kisten;

    /**
     * Creëer een nieuwe kistenvuller
     */
    public Kistenvuller () {
        kisten = new ArrayList<Kist>();
    }

    /**
     * Voeg een kist toe aan de lijst van kisten die kunnen gevuld
     * worden.
     */
    public void nieuweKist (Kist kist) {
        kisten.add (kist);
    }

    /**
     * Plaats het bord in de eerste kist waar er nog plaats is. Geef het
     * volgnummer van de kist terug of -1 als dit niet meer lukt.
     * BELANGRIJK: Als het wel lukt geef je het bord aan die kist en druk je het 
     *   nummer van die kist af.
     */
    private int bergEenBordOp (Bord bord) {
        int aantal = kisten.size ();
        int i = 0;
        while (i < aantal && ! kisten.get(i).isAanvaardbaar (bord) ) {
            i++;
        }
        if (i < aantal) {
            kisten.get(i).nieuwBord(bord);
            System.out.println ("Bord: " + bord); 
            System.out.println (" in kist nr. " + i);            
            return i;
        } else {
            return -1;
        }
    }
    
    /**
     * Vul de kisten met de opgegeven borden. Stop als de kisten vol
     * zijn of als de lijst leeg is. Drukt af welke
     * kist er telkens gebruikt wordt. Drukt op het einde af
     * hoeveel borden er geplaatst zijn.
     */
    public void vulKisten (List<Bord> borden) {
        int i = 0;
        while (i < borden.size() && bergEenBordOp(borden.get(i)) >= 0) {
            i++;
        }
        System.out.println (i + " borden geplaatst");
    }
    
}
